$Title Electricity Model
$ontext
--------------------------------------------------------------------------------
------------------------------ General Header ----------------------------------
--------------------------------------------------------------------------------
         SAM disaggregation in load blocks
         Renato Rodrigues
         Instituto de Investigacin Tecnolgica
         Date: 20, jul, 2011
--------------------------------------------------------------------------------
--------------------------- End of General Header ------------------------------
--------------------------------------------------------------------------------
$offtext

parameter
SAM_output(y,*,*,*,*,*,*,*,*,*,*,*);


********Unchanged SAM values *************
SAM_output(ey,n_e_SAM_row,"","","","",n_e_SAM_column,"","","","","")=SAM_table(n_e_SAM_row,n_e_SAM_column);
********Changed SAM values *************
SAM_output(ey,gne,"","","","","Electricity","TDeO","","","","")=Q_II_GNE_TDeO_HGEMED.l(ey,gne)*P_Q_HGEMED.l(ey,gne);
SAM_output(ey,gne,"","","","","Electricity","GEN",l,gp,gb,t)=Q_II_GNE_GEN_tech_HGEMED.l(ey,gne,l,gp,gb,t)*P_Q_HGEMED.l(ey,gne);
SAM_output(ey,"Electricity","Power","","","",sne,"","","","","")=Q_II_TDeO_SNE_HGEMED.l(ey,sne)*P_Q_TDeO_HGEMED.l(ey);
SAM_output(ey,"Electricity","Energy",l,dp,db,sne,"","","","","")=Q_II_GEN_SNE_HGEMED.l(ey,l,dp,db,sne)*P_Q_GEN_HGEMED.l(ey,l,dp,db);
SAM_output(ey,"Electricity","Energy",l,dp,db,"Electricity","TDeO","","","","")=Q_II_GEN_TDeO_HGEMED.l(ey,l,dp,db)*P_Q_GEN_HGEMED.l(ey,l,dp,db);
SAM_output(ey,"Electricity","Energy",l,dp,db,"Electricity","GEN",l,gp,gb,t)=Q_II_GEN_GEN_tech_HGEMED.l(ey,l,dp,db,gp,gb,t)*P_Q_GEN_HGEMED.l(ey,l,dp,db);
SAM_output(ey,"Government","","","","","Electricity","GEN",l,p,b,t)= - emissions_allowance(ey,l,p,b,t);
SAM_output(ey,pf,"","","","","Electricity","GEN",l,gp,gb,t)= ( Q_PF_LABOR_GEN_tech_HGEMED.l(ey,l,gp,gb,t)*P_PF_LABOR_HGEMED.l(ey) )$(SAMEAS(pf,"Labor")) + ( Q_PF_CAPITAL_GEN_tech_HGEMED.l(ey,l,gp,gb,t)*P_PF_CAPITAL_HGEMED.l(ey) )$(SAMEAS(pf,"Capital"));
SAM_output(ey,pf,"","","","","Electricity","TDeO","","","","")= ( Q_PF_LABOR_TDeO_HGEMED.l(ey)*P_PF_LABOR_HGEMED.l(ey) )$(SAMEAS(pf,"Labor")) + ( Q_PF_CAPITAL_TDeO_HGEMED.l(ey)*P_PF_CAPITAL_HGEMED.l(ey) )$(SAMEAS(pf,"Capital"));


SAM_output(ey,"Production_Taxes","","","","","Electricity","GEN",l,p,b,"GEN Production Tax") = production_tax_GEN(ey,l,p,b);

************ TO BE UPDATED
SAM_output(ey,tx,"","","","","Electricity","GEN",l,p,b,t)= ( ( sum(gne, tx_rate_tech(ey,l,p,b,t,"Product_tax")*P_Q_HGEMED.l(ey,gne)*Q_II_GNE_GEN_tech_HGEMED.l(ey,gne,l,p,b,t)) ) + tx_rate_tech(ey,l,p,b,t,"Product_tax")*P_Q_TDeO_HGEMED.l(ey)*Q_II_TDeO_GEN_tech_HGEMED.l(ey,l,p,b,t) + sum((dp,db), tx_rate_tech(ey,l,p,b,t,"Product_tax")*P_Q_GEN_HGEMED.l(ey,l,dp,db)*Q_II_GEN_GEN_tech_HGEMED.l(ey,l,dp,db,p,b,t))  )$(SAMEAS(tx,"Product_tax")) +
$ontext
                                                                 tx_rate(ey,"Electricity","Production_Taxes")*(
                                                                       sum(gne, P_Q_HGEMED.l(ey,gne)*Q_II_GNE_GEN_tech_HGEMED.l(ey,gne,l,p,b,t))
                                                                     + sum((dp,db), P_Q_GEN_HGEMED.l(ey,l,p,b)*Q_II_GEN_GEN_tech_HGEMED.l(ey,l,dp,db,p,b,t))
                                                                     + P_Q_TDeO_HGEMED.l(ey)*Q_II_TDeO_GEN_tech_HGEMED.l(ey,l,p,b,t)
                                                                     + P_PF_LABOR_HGEMED.l(ey)*Q_PF_LABOR_GEN_tech_HGEMED.l(ey,l,p,b,t)
                                                                     + P_PF_CAPITAL_HGEMED.l(ey)*Q_PF_CAPITAL_GEN_tech_HGEMED.l(ey,l,p,b,t)
                                                                     + ( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED.l(ey,l,t) / 10**3 )
                                                                     + ( tx_rate(ey,"Electricity","Product_tax")*( sum(gne, P_Q_HGEMED.l(ey,gne)*Q_II_GNE_GEN_tech_HGEMED.l(ey,gne,l,p,b,t)) + sum((dp,db), P_Q_GEN_HGEMED.l(ey,l,p,b)*Q_II_GEN_GEN_tech_HGEMED.l(ey,l,dp,db,p,b,t)) +  P_Q_TDeO_HGEMED.l(ey)*Q_II_TDeO_GEN_tech_HGEMED.l(ey,l,p,b,t) ) )
*                                                                    - emissions_allowance(ey,l,p,b,t)
*                                                                    + ( sum((f)$emitting_t(t,f), PGEN_HGEMED.l(ey,t,f,l,p,b)*co2e_content_HGEMED(f,t)/1e6*co2_price(ey)*duration(l,p,b)) )$(SAMEAS(tx,"CO2_Payments"))
                                                                 )
                                                            )$(SAMEAS(tx,"Production_Taxes")) +
$offtext
*                                                           ( sum((f)$emitting_t(t,f), PGEN_HGEMED.l(ey,t,f,l,p,b)*co2e_content_HGEMED(f,t)/1e6*co2_price(ey)*duration(l,p,b)) )$(SAMEAS(tx,"CO2_Payments")) +
                                                                 ( (sum((f,pollut)$emitting_t(t,f), PGEN_HGEMED.l(ey,t,f,l,p,b)*duration(l,p,b)*pollut_content_HGEMED(ey,t,f,pollut)/1e6*pollutant_price(ey,pollut,"Electricity"))))$(SAMEAS(tx,"CO2_Payments")) +

                                                                 ( dist_factor_HGEMED(ey,l,p,b)*duration(l,p,b)*init_oem_fom_social_contribution_HGEMED(ey,l,t)*INSTALLED_CAPACITY_HGEMED.l(ey,l,t) / 10**3 )$(SAMEAS(tx,"Social_Contributions"));




*????????????         + sum((sne,pollut)$ets_sne(sne), top_down_pollutant_content(ey,pollut,sne)*(initial_P_S_HGEMED(ey,sne)/(initial_Q_S_HGEMED(ey,sne)*initial_P_S_HGEMED(ey,sne)))*Q_S_HGEMED(ey,sne)*pollutant_price(ey,pollut,sne) )
*????????????         + sum(pollut, top_down_pollutant_content(ey,pollut,"Households")*( sum(gne, (initial_P_Q_HGEMED(ey,gne)/(initial_Q_H_D_HGEMED(ey,gne)*initial_P_Q_HGEMED(ey,gne)))*Q_H_D_HGEMED(ey,gne)) + (initial_P_Q_TDeO_HGEMED(ey)/(initial_Q_H_D_TDeO_HGEMED(ey)*initial_P_Q_TDeO_HGEMED(ey)))*Q_H_D_TDeO_HGEMED(ey) + sum((l,p,b), (initial_P_Q_GEN_HGEMED(ey,l,p,b)/(initial_Q_H_D_GEN_HGEMED(ey,l,p,b)*initial_P_Q_GEN_HGEMED(ey,l,p,b)))*Q_H_D_GEN_HGEMED(ey,l,p,b)) )*pollutant_price(ey,pollut,"Households"))


$ontext
                                                           tx_rate_sc(ey,"Labor",s)= e_tx_sam(ey,"Social_Contributions",s)/e_pf_s(ey,"Labor",s);
tx_rate(ey,s,"Production_Taxes")= e_tx_sam(ey,"Production_Taxes",s)/
(sum(g,e_ii_s(ey,g,s))+
sum(pf,e_pf_s(ey,pf,s))+
e_tx_sam(ey,"Social_Contributions",s)
+ e_tx_sam(ey,"Product_Tax",s)+
e_tx_sam(ey,"CO2_Payments",s)
-sum(i,e_transf_i_s(ey,i,s)));
tx_rate(ey,sam,"Product_Tax")= (e_tx_sam(ey,"Product_Tax",sam)/sum(g,SAM_table(g,sam)))$(sum(g,SAM_table(g,sam))<>0);
$offtext

SAM_output(ey,tx,"","","","","Electricity","TDeO","","","","")= ( sum(gne, tx_rate_TDeO(ey,"Product_tax")*P_Q_HGEMED.l(ey,gne)*Q_II_GNE_TDeO_HGEMED.l(ey,gne)) + tx_rate_TDeO(ey,"Product_tax")*P_Q_TDeO_HGEMED.l(ey)*Q_II_TDeO_TDeO_HGEMED.l(ey) + sum((l,p,b), tx_rate_TDeO(ey,"Product_tax")*P_Q_GEN_HGEMED.l(ey,l,p,b)*Q_II_GEN_TDeO_HGEMED.l(ey,l,p,b)) )$(SAMEAS(tx,"Product_tax")) +
                                                             ( tx_rate_TDeO(ey,"Production_taxes")*P_S_TDeO_HGEMED.l(ey)*Q_S_TDeO_HGEMED.l(ey) )$(SAMEAS(tx,"Production_Taxes")) +
                                                             ( 0 )$(SAMEAS(tx,"CO2_Payments")) +
                                                             ( tx_rate_sc_TDeO(ey,"Labor")*P_PF_LABOR_HGEMED.l(ey)*Q_PF_LABOR_TDeO_HGEMED.l(ey) )$(SAMEAS(tx,"Social_Contributions"));



***********

SAM_output(ey,"Imports","","","","","Electricity","GEN",l,gp,gb,"Imports")=p_m_GEN_HGEMED(ey,l,gp,gb)*q_m_GEN_HGEMED(ey,l,gp,gb);
SAM_output(ey,"Imports","","","","","Electricity","TDeO","","","","")=0;
SAM_output(ey,"Capital","","","","","Electricity","GEN",l,p,b,"GEN_market_failure_and_non_accounted_costs")= mkt_surplus_HGEMED.l(ey,l,p,b);

SAM_output(ey,"Electricity","Energy",l,dp,db,i,"","","","","")= ( Q_H_D_GEN_HGEMED.l(ey,l,dp,db)*P_Q_GEN_HGEMED.l(ey,l,dp,db) )$(SAMEAS(i,"Households")) + 0;
SAM_output(ey,"Electricity","Power","","","",i,"","","","","")= ( Q_H_D_TDeO_HGEMED.l(ey)*P_Q_TDeO_HGEMED.l(ey) )$(SAMEAS(i,"Households")) + 0;
SAM_output(ey,"Electricity","Energy",l,dp,db,"Exports","","","","","")=p_ex_GEN_HGEMED(ey,l,dp,db)*q_ex_GEN_HGEMED(ey,l,dp,db);
SAM_output(ey,"Electricity","Power","","","","Exports","","","","","")=0;

option SAM_output:0:5:7;

*---------Declaration of auxiliary file-------
file TMPHGEMED /TMPHGEMED.txt/
put TMPHGEMED  putclose
                         'par=SAM_output rng=Disaggregated_SAM!D6 Rdim=6'

*---------GAMs loading data-------------------
execute_unload "results.gdx"

*---------GAMs loading data-------------------
execute        'gdxxrw.exe results.gdx o="Output_Model_%Model%_%Load_Block_Aggregation%_%Calibration_Problem%_%Years_Simulated%_HGEMED.xlsx" SQ=n Squeeze=0 EpsOut=0 @TMPHGEMED.txt'

*---------Deleting Auxiliary Files--
execute 'del TMPHGEMED.txt results.gdx';







